#ifndef __CBOXMESH_H__
#define __CBOXMESH_H__

#include "imesh.h"

class CBoxMesh : public IMesh
{
public:
	bool GenerateBox(CDmaVif1 * pDmaVif1, int iWidthSegs, float fWidthDim, 
					 int iHeightSegs, float fHeightDim,
					 int iLengthSegs, float fLengthDim);

	void * GetDMA_Tags() { return m_pDmaTags; }
	
	CBoxMesh();


private:
	bool GenerateSurf(int iSurf, int iWDim, int iHDim, SRenderGadget * pCurStrips);
	void CBoxMesh::GetNormal(int iSurf, int i, int j, int iWDim, int iHDim, float * pNorm);
	void GetPoint(int iSurf, int i, int j, float * pVert, int * pCol);
	void CleanUp();
	void CleanStrips(SRenderGadget * pStrips, int iTotStrips);


	int m_iNumOfUniqueVerts;

	int * m_pUniCols;
	float * m_pUniVerts;
	int * m_iPointID;

private:	// User-defined
	int m_iWidthSegs;
	int m_iHeightSegs;
	int m_iLengthSegs; 

	float m_fWidthDim;
	float m_fHeightDim;
	float m_fLengthDim;
	void * m_pDmaTags;
};


#endif
