#ifndef __IMESH_H__
#define __IMESH_H__

#include "meshstructs.h"
#include "exttypes.h"
#include "dmavif1.h"


#define PAD_CHUNK	3		// Matrix, Lights, NumOfStrips, NumOfLights, e.t.c.
#define HUNK_SIZE	330



struct SStripChunk
{
	int m_iNumOfStrips;
	int m_iNumElemsInChunk;	// 1 elem = {point, color, UV}

	uint128 m_uGifTagStrip;
	uint128 m_uGifTagTriangle;

	int m_pSpace[4];	// iNumStripsInChunk, iNumElemsInChunk, zzz, www
	
	int * m_pNumVertsInStrip;	// array is length m_iNumOfStrips
	float * m_pVerts;		// array is length m_iNumElemsInChunk
	int * m_pCols;
	float * m_pTexCrds;
};

class IMesh
{
	friend class IMeshInstance;

public:
	IMeshInstance * CreateInstance(CDmaVif1 * pInstDmaVif1);

	IMesh();

//protected:
	bool ConvertToChunk(CDmaVif1 * pDmaVif1, SRenderGadget * pAllStrips, int iTotalNumOfStrips);
	virtual void CleanUp();

//private:
	int m_iNumOfChunks;
	SStripChunk * m_pChunks;
};


#endif
