/**
 * This tests shows direct access to the GS registers.
 * It also shows that you could map them more than once (therefore
 * you don't have to worry if multiple modules map the registers).
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>

#include "sps2lib.h"

#include "packet.c"

void *pvPointer;
void *pvPointer2;

sps2Memory_t *pMemory;
int iDevice, iDevice2;

int main() {
  int x;
  iDevice=sps2Init();
  iDevice2=sps2Init();

  if (iDevice<0) {
    fprintf(stderr,"Error opening sps2 device!\n");
    exit(-1);
  }

  for (x=0;x<255;x+=32) { 
   DPUT_GS_BGCOLOR(x);
    sleep(1);
  }

  for (x=0;x<255;x+=32) {
    DPUT_GS_BGCOLOR(x << 8);
    sleep(1);
  }

  printf("%i %i\n",sizeof(int), sizeof(long));

  if (iDevice<0) {
    perror("Error opening device");
    return -1;
  }

  //  pMemory=sps2Allocate(16384, iDevice);
  pMemory=sps2Allocate(16384, SPS2_MAP_BLOCK_4K, iDevice);

  if (pMemory==0) {
    perror("Error allocating memory");
    return -1;
  }

  printf("'%c'\n",((char *) pMemory->pvStart)[128]);
  printf("'%c'\n",((char *) pMemory->pvStart)[4096+128]);
  printf("'%c'\n",((char *) pMemory->pvStart)[8192+128]);
  printf("'%c'\n",((char *) pMemory->pvStart)[128]);

  sps2Free(pMemory);

  
  DPUT_GS_BGCOLOR(0xffffffLL);

  sps2Release(iDevice);
  sps2Release(iDevice2);

  return 0;
}
