/**
 * This tests illustrates writing to the scratch pad using DMA
 * and reading from it by mapping the scratch pad directly.
 * The latter part is not yet functioning.
 */

#include <stdio.h>
#include "exttypes.h"

#define GEN_REF_TAG(Addr, iQuadCount)			((uint64(Addr) << 32) | (0x3 << 28) | iQuadCount)
#define GEN_CNT_TAG(iQuadCount)					((uint64(0x1) << 28) | iQuadCount)
#define GEN_END_TAG(iQuadCount)					((uint64(0x7) << 28) | iQuadCount)

#include "sps2lib.h"
#include "sps2tags.h"

int iSPS2Device;
sps2Memory_t *pDescriptor;
void *pvEERegisters;

// Get me unswapable memory
void * magicalloc(uint32 uRequestBytes)
{
  pDescriptor=sps2Allocate(uRequestBytes, SPS2_MAP_BLOCK_4K,
			   iSPS2Device);

  if (pDescriptor) {
    return pDescriptor->pvStart;
  }

  return NULL;	// returns NULL for now
}

void * convert_to_phys(void * pVirtAddr)
{
  printf("Physical of %08x is %08x\n",
	 (uint32) pVirtAddr,
	 (uint32) sps2GetPhysicalAddress(pVirtAddr, pDescriptor));

  return (void *)  sps2GetPhysicalAddress(pVirtAddr, pDescriptor);

  //	return NULL;	// returns NULL for now
}

void FlushCache(uint32 uType)
{
  sps2FlushCache(iSPS2Device);
}

// Set channel9 props (To ScratchPad)
void SetD9_TADR(uint32 uChainPtr)
{
  // *D9_TADR = (uint32) uChainPtr&0x0fffffff;

  *EE_D9_TADR=uChainPtr & 0x0fffffff;
  printf ("Want to write %08x to %08x\n",
	  uChainPtr, (uint32) EE_D9_TADR);


}

void SetD9_SADR(uint32 uSPDeliveryAddr)		// ScratchPad address
{
  // *D9_SADR = (uint32) uSPDeliveryAddr&0x3fff;

  *EE_D9_SADR=uSPDeliveryAddr & 0x3fff;
  printf ("Want to write %08x to %08x\n",
	  uSPDeliveryAddr, (uint32) EE_D9_SADR);


}


void SetD9_CHCR(uint32 uTriggerCode)		// ScratchPad address
{
  // *D9_CHCR = (uint32) uTriggerCode&0x3fff;

  *EE_D9_CHCR=uTriggerCode & 0x3fff;
  printf ("Want to write %08x to %08x\n",
	  uTriggerCode, (uint32) EE_D9_CHCR);


}

sps2DMATag_t t;
void printTag(sps2DMATag_t tag) {
  printf("QWC=%08x PCE=%i ID=%i IRQ=%i ADDR=%08x SPR=%i\n",
	 tag.s.QWC, tag.s.PCE, tag.s.ID, tag.s.IRQ,
	 tag.s.ADDR, tag.s.SPR);
}
  




int main()
{

	// Fill up buffer1
	int i;

	iSPS2Device=sps2Init();
	char * ptr = (char *) magicalloc(4096*3);
	printf("Device opened and memory is %08x\n",(uint32) ptr);

	//	pvEERegisters=sps2MapEERegisters(iSPS2Device);

	//	printf("Registers are at %08x\n",(uint32) pvEERegisters);

	uint32 * pFill = (uint32 *) (ptr+1*4096);
	for(i=0; i<1024; i++)
		pFill[i] = 0x3c4c5c6c;


	// Fill up buffer2
	pFill = (uint32 *) (ptr+2*4096);
	for(i=0; i<1024; i++)
		pFill[i] = 0xa9b9c9d9;

	// convert to phys
	void * pPhysPage1 = convert_to_phys((void *) (ptr+0*4096));
	void * pPhysPage2 = convert_to_phys((void *) (ptr+1*4096));
	void * pPhysPage3 = convert_to_phys((void *) (ptr+2*4096));

	// Insert RefTags (make 4 x 2kb deliveries)
	uint64 * pTags = (uint64 *) (ptr+0*4096);

	// First page delivery
	*pTags++ = t.i64=GEN_REF_TAG((uint32) pPhysPage2, 128);
	printTag(t);
	*pTags++ = 0;	// clear
	
	*pTags++ = t.i64=GEN_REF_TAG((((uint32) pPhysPage2)+2048), 128);
	printTag(t);
	*pTags++ = 0;	// clear

	// Second page delivery
	*pTags++ = t.i64=GEN_REF_TAG((uint32) pPhysPage3, 128);
	printTag(t);
	*pTags++ = 0;	// clear
	*pTags++ = t.i64=GEN_REF_TAG((((uint32) pPhysPage3)+2048), 128);
	printTag(t);
	*pTags++ = 0;	// clear

	// Deliver End Tag
	*pTags++ = t.i64=GEN_END_TAG(1);
	printTag(t);
	*pTags++ = 0;	// clear

	((char *)pTags)[0] = 'h'; 
	((char *)pTags)[1] = 'e'; 
	((char *)pTags)[2] = 'l'; 
	((char *)pTags)[3] = 'l'; 
	((char *)pTags)[4] = 'o'; 
	((char *)pTags)[5] = ' '; 
	((char *)pTags)[6] = 'S'; 
	((char *)pTags)[7] = 'a'; 
	((char *)pTags)[8] = 'u'; 
	((char *)pTags)[9] = 'c'; 
	((char *)pTags)[10] = 'e'; 
	((char *)pTags)[11] = '\0'; 
	((char *)pTags)[12] = 0;
	((char *)pTags)[13] = 0;
	((char *)pTags)[14] = 0;
	((char *)pTags)[15] = 0;

	// Make Sure data is not stuck in the cache
	FlushCache(0);

	// Trigger transfer
	//asm("sync.l");
	//assert( ((*D9_CHCR)&0x0100)==0 );
	SetD9_TADR(	(uint32 ) pPhysPage1);
	SetD9_SADR(	(uint32 ) 0);
	*EE_D9_QWC=0;


	/*	int iValidate=sps2ValidateDMA(iSPS2Device,9,(1<<2) | (1<<8),0);
	if (iValidate<0) {
	  printf("Chain validation failed.  Exiting\n");
	  exit(-1);
	} else {
	  printf("Chain is %i bytes in size\n", iValidate);
	  }*/

	SetD9_CHCR((1<<2) | (1<<8));
	//asm("sync.l");
	//	sleep(1);
	sps2WaitForDMA(9, iSPS2Device);

	FILE *pfTest1=fopen("spr.data","wb");
	printf("Fwrite returns %i\n", fwrite(SCRATCH_PAD,16384,1,pfTest1));
	fclose(pfTest1);

	return 0;
}
